<?php
defined('BASEPATH') OR exit('No direct script access allowed');


class AlarmasModels extends CI_Model
{

public function Alarma(){

  $Token = obtnerToken();
  $Autho = "";
  if($Token != FALSE){
  $Autho =str_replace('Bearer ','', $Token);
  }
  if( $Autho !=""){
  $Autho =str_replace('Bearer ','', $Autho);
  $Token = ValidarToken($Autho);
  }
  if(isset($this->session)){
    $ID =  $Token== FALSE ? $this->session->userdata("User") :  $Token ;
}else{
    $ID =   $Token== FALSE ? null :  $Token ;
}
   if ($ID === null && $Token === FALSE ){
    $DatosGET= isset($_GET["x"]) ? $_GET["x"]: "" ;
    $DatosGET =  $DatosGET!=""?ValidarToken($DatosGET) :"";
    $ID =$DatosGET!=''?$DatosGET: $ID;
   }
  
    $Datos = $this->UserModels->getUser($ID);
    $this->db->select(array("Diario"));
    $this->db->where('Codigo',$this->db->escape($Datos[0]->Tienda),false);
    $this->db->where('Diario < ',$this->db->escape(date("Y-m-d")),false);
    $Datos2 =  $this->db->get('tienda')->result();
 
   
    if(count($Datos2) >0 ){
      ignore_user_abort(true); 
      set_time_limit(0);
        $where = "Codigo = '".$Datos[0]->Tienda."' ";
       $this->db->update('tienda',array('Diario'=> date("Y-m-d") ) , $where );
        
        $this->AlarmaCertificadoBalsa();
        $this->AlarmaExtinguisher();
        $this->AlarmaGeneral();
        $this->AlarmaCertificadoTraje();
        $this->AlarmaAirCylinde();

        
      
        return true;
       }else{
      
        return False;

       }

}

public function AlarmaAirCylinde(){
  
    $ArrayBalsasPorVencer = $this->AirCylinderModels->Alarma();
    
    foreach ($ArrayBalsasPorVencer as $Fila){
      $Usuario= $this->ClientModels->getClient($Fila->Armador);
      $Serial = $Fila->Serie;
      $DatosEditar = '{"0":"'. $Fila->ID.'", "12":"1"}';
      $DatosEditar =  json_decode($DatosEditar, true);
      $isn= $this->AirCylinderModels->Edit($DatosEditar);
    if($Usuario[0]->Correo != ""){
      $htmlContent = '<h1>Certificado de Cilindro De Aire</h1>';
      $htmlContent .="<p> Su Cilindro De Aire : $Serial, Esta Por VENCER actualmente tiene una vigencia de 30 dias.</p>";
      EmailHtml($Usuario[0]->Correo,"SEGMARIND ADVERTENCIA", $htmlContent);
    };
    }
    $ArrayBalsasVencidas = $this->AirCylinderModels->Alarma2();
    foreach ($ArrayBalsasVencidas as $Fila){
      $Usuario= $this->ClientModels->getClient($Fila->Armador);
      $DatosEditar = '{"0":"'. $Fila->ID.'","9":"Vencido", "12":"2"}';
        $DatosEditar =  json_decode($DatosEditar, true);
       
        $isn= $this->AirCylinderModels->Edit($DatosEditar);
      if($Usuario[0]->Correo != ""){
    
        $Serial = $Fila->Serie;
        $htmlContent = '<h1>Certificado De Aire </h1>';
        $htmlContent .="<p> Su Extintor: $Serial, Esta Vencidad actualmente deber renovar su Certificado .</p>";
        EmailHtml($Usuario[0]->Correo,"SEGMARIND ADVERTENCIA", $htmlContent);
     
        $this->MinutesModels->Edit($DatosEditar);
        
      };
      }
  
  }

  public function AlarmaCertificadoBalsa(){
    $ArrayBalsasPorVencer = $this->AlarmaBalsasModels->getAlarmaBalsas();
  
    if(count($ArrayBalsasPorVencer)>0){
      $ArrayEnviar = array(); 
      foreach ($ArrayBalsasPorVencer as $Fila){
        $DatosEditar = '{"0":"'. $Fila->ID.'", "15":"1"}';
        $DatosEditar =  json_decode($DatosEditar, true);
        $isn= $this->RaftModels->Edit($DatosEditar);
        if($Fila->Correo != ""){
          if (!isset($ArrayEnviar[$Fila->Correo])){
            $ArrayEnviar[$Fila->Correo] =  array(1,"");
          
            $ArrayEnviar[$Fila->Correo][1] .= "<p> Su Certificado de Balsa: $Fila->Serial, Esta Por VENCER actualmente tiene una vigencia de 30 dias.</p>";
          }else{
            $ArrayEnviar[$Fila->Correo][0]++;
            $ArrayEnviar[$Fila->Correo][1].= "<p> Su Certificado de Balsa: $Fila->Serial, Esta Por VENCER actualmente tiene una vigencia de 30 dias.</p>";
          }
        
       
         
          $htmlContent = '<h1>Certificado De Balsa Salvavidas</h1>';
          $htmlContent .="<p> Su Certificado de Balsa: $Fila->Serial, Esta Por VENCER actualmente tiene una vigencia de 30 dias.</p>";
          EmailHtml($Fila->Correo,"SEGMARIND ADVERTENCIA", $htmlContent);
        };
        }
        foreach ( $ArrayEnviar as $clave => $valor){
          $Cantidad = $valor[0];
          $htmlContent = '<h1>Certificado De Balsa Salvavidas</h1>';
          $htmlContent .="<h4>Actualmente posee  $Cantidad  Balsa Salvavidas  por Vencer  deber renovar sus certificado </h4>" ;
          $htmlContent .=  $valor[1];
          EmailHtml($clave,"SEGMARIND ADVERTENCIA", $htmlContent);
    
        }    





    }
    
    $ArrayBalsasVencidas = $this->AlarmaBalsasModels->getAlarmaBalsas2();
   
    if(count($ArrayBalsasVencidas)>0){
      $ArrayEnviar = array(); 
      foreach ($ArrayBalsasVencidas as $Fila){
        $DatosEditar = '{"0":"'. $Fila->ID.'","13":"Vencido", "15":"2"}';
        $DatosEditar =  json_decode($DatosEditar, true);
        $isn= $this->RaftModels->Edit($DatosEditar);
        $Cert = $Fila->Certificado;
        $Acta = $this->MinutesFModels->getMinutesFFiltro("sCertificado^$Cert");
        $DatosEditar = '{"0":"'.$Acta[0]->ID.'","11":"Vencido"}';
        $DatosEditar =  json_decode($DatosEditar, true);
        $this->MinutesModels->Edit($DatosEditar);
        if($Fila->Correo != ""){
          $Serial = $Fila->Serial;
         
            

          if (!isset($ArrayEnviar[$Fila->Correo])){
            $ArrayEnviar[$Fila->Correo] =  array(1,"");
          
            $ArrayEnviar[$Fila->Correo][1] .= "<p> Su Balsa: $Serial, Esta Vencidad actualmente deber renovar su certificado de inspeccion.</p>";
          }else{
            $ArrayEnviar[$Fila->Correo][0]++;
            $ArrayEnviar[$Fila->Correo][1].= "<p> Su Balsa:  $Serial, Esta Vencida actualmente deber renovar su certificado de inspeccion.</p>";
          }
        
          
        };
        
        }
        foreach ( $ArrayEnviar as $clave => $valor){
          $Cantidad = $valor[0];
          $htmlContent = '<h1>Certificado De Balsa Salvavidas</h1>';
          $htmlContent .="<h4>Actualmente posee  $Cantidad  Balsa Salvavidas  Vencidas  deber renovar sus certificado </h4>" ;
          $htmlContent .=  $valor[1];
          EmailHtml($clave,"SEGMARIND ADVERTENCIA", $htmlContent);
    
        }    


  
    }
  
   
  
  }
  private function Tipo($value){
    switch ($value) {
     case '1':
       # code...
     return "INSPECCION BANCO CO2";
     case '2':
       # code...
     return "INSPECCION TRAJE INMERSION";
     default:
       # code...
       return " INSPECCION BANCO EXTINCION INCENDIO";
    }
   }
  Public function AlarmaGeneral(){
    $ArrayPorVencer = $this->OrdenesGModels->Alarma();
    $ArrayEnviar = array(); 
    foreach ($ArrayPorVencer as $Fila){ 
      $Serial = $Fila->Certificado;
      $Tipo=   $this->Tipo($Fila->Tipo);
      $DatosEditar = '{"0":"'. $Fila->ID.'", "11":"5"}';
      $DatosEditar =  json_decode($DatosEditar, true);
      $isn= $this->ExtinguisherModels->Edit($DatosEditar);
   
    if($Fila->Correo != ""){
      

      if (!isset($ArrayEnviar[$Fila->Correo])){
        $ArrayEnviar[$Fila->Correo] =  array(1,"");
        $ArrayEnviar[$Fila->Correo][1] .= "<p>: CERTIFICADO DE $Tipo :  $Serial, Esta Por VENCER actualmente tiene una vigencia de 30 dias.</p>";
      }else{
        $ArrayEnviar[$Fila->Correo][0]++;
        $ArrayEnviar[$Fila->Correo][1].= "<p> CERTIFICADO DE $Tipo :  $Serial, Esta Por VENCER actualmente tiene una vigencia de 30 dias.</p>";
      }
      $htmlContent = "<h1>Certificado  $Tipo </h1>";
      $htmlContent .="<p> CERTIFICADO DE $Tipo : $Serial, Esta Por VENCER actualmente tiene una vigencia de 30 dias.</p>";
     // EmailHtml($Fila->Correo,"SEGMARIND ADVERTENCIA", $htmlContent);
    };
    }
    foreach ( $ArrayEnviar as $clave => $valor){
      $Cantidad = $valor[0];
      $htmlContent = "<h1>Certificado   </h1>";
      $htmlContent .="<h4>Actualmente posee  $Cantidad CERTIFICADOS  por vencer  deber renovar sus certificado </h4>" ;
      $htmlContent .=  $valor[1];
      EmailHtml($clave,"SEGMARIND ADVERTENCIA", $htmlContent);

    }

    $ArrayVencidas = $this->OrdenesGModels->Alarma2();
    foreach ($ArrayVencidas as $Fila){
     
      $DatosEditar = '{"0":"'. $Fila->ID.'","11":"3"}';
        $DatosEditar =  json_decode($DatosEditar, true);
       
        $isn= $this->OrdenesGModels->Edit($DatosEditar);
      if($Fila->Correo != ""){
        $Serial = $Fila->Certificado;
        $Tipo=   $this->Tipo($Fila->Tipo);
        if (!isset($ArrayEnviar[$Fila->Correo])){
          $ArrayEnviar[$Fila->Correo] =  array(1,"");
          $ArrayEnviar[$Fila->Correo][1] .= "<p> CERTIFICADO DE $Tipo :  $Serial,  Esta Vencidad actualmente deber renovar su certificado .</p>";
        }else{
          $ArrayEnviar[$Fila->Correo][0]++;
          $ArrayEnviar[$Fila->Correo][1].= "<p> CERTIFICADO DE $Tipo :  $Serial, Esta Vencidad actualmente deber renovar su certificado .</p>";
        }
        
        
       // EmailHtml($Fila->Correo,"SEGMARIND ADVERTENCIA", $htmlContent);
     
        
        
      };
  
      }
      foreach ( $ArrayEnviar as $clave => $valor){
        $Cantidad = $valor[0];
        $htmlContent = "<h1>Certificado  </h1>";
        $htmlContent .="<h4>Actualmente posee  $Cantidad Certificado VENCIDOS  deber renovar sus certificado </h4>" ;
        $htmlContent .=  $valor[1];
        EmailHtml($clave,"SEGMARIND VENCIDO", $htmlContent);

      }    

  }
  public function AlarmaExtinguisher(){

  
    $ArrayBalsasPorVencer = $this->ExtinguisherModels->Alarma();  
 
    $ArrayEnviar = array(); 
    foreach ($ArrayBalsasPorVencer as $Fila){ 
      $Serial = $Fila->Serial;
      $DatosEditar = '{"0":"'. $Fila->ID.'", "16":"1"}';
      $DatosEditar =  json_decode($DatosEditar, true);
      $isn= $this->ExtinguisherModels->Edit($DatosEditar);
   
    if($Fila->Correo != ""){
      

      if (!isset($ArrayEnviar[$Fila->Correo])){
        $ArrayEnviar[$Fila->Correo] =  array(1,"");
        $ArrayEnviar[$Fila->Correo][1] .= "<p>Extintor: $Serial, Esta Por VENCER actualmente tiene una vigencia de 30 dias.</p>";
      }else{
        $ArrayEnviar[$Fila->Correo][0]++;
        $ArrayEnviar[$Fila->Correo][1].= "<p>Extintor: $Serial, Esta Por VENCER actualmente tiene una vigencia de 30 dias.</p>";
      }
      $htmlContent = '<h1>Certificado De Extintores</h1>';
      $htmlContent .="<p> Su Extintor: $Serial, Esta Por VENCER actualmente tiene una vigencia de 30 dias.</p>";
     // EmailHtml($Fila->Correo,"SEGMARIND ADVERTENCIA", $htmlContent);
    };
    }
    foreach ( $ArrayEnviar as $clave => $valor){
      $Cantidad = $valor[0];
      $htmlContent = "<h1>Certificado Extintores  </h1>";
      $htmlContent .="<h4>Actualmente posee  $Cantidad Extintores  por vencer  deber renovar sus certificado </h4>" ;
      $htmlContent .=  $valor[1];
      EmailHtml($clave,"SEGMARIND ADVERTENCIA", $htmlContent);

    }    
  
    $ArrayBalsasVencidas = $this->ExtinguisherModels->Alarma2();
   $ArrayEnviar = array();
    foreach ($ArrayBalsasVencidas as $Fila){
     
      $DatosEditar = '{"0":"'. $Fila->ID.'","11":"Vencido", "16":"2"}';
        $DatosEditar =  json_decode($DatosEditar, true);
       
        $isn= $this->ExtinguisherModels->Edit($DatosEditar);
      if($Fila->Correo != ""){
        $Serial = $Fila->Serial;
        if (!isset($ArrayEnviar[$Fila->Correo])){
          $ArrayEnviar[$Fila->Correo] =  array(1,"");
          $ArrayEnviar[$Fila->Correo][1] .= "<p>Extintor: $Serial, Esta Vencidad actualmente deber renovar su certificado .</p>";
        }else{
          $ArrayEnviar[$Fila->Correo][0]++;
          $ArrayEnviar[$Fila->Correo][1].= "<p>Extintor: $Serial, Esta Vencidad actualmente deber renovar su certificado .</p>";
        }
        
        
       // EmailHtml($Fila->Correo,"SEGMARIND ADVERTENCIA", $htmlContent);
     
        
        
      };
  
      }
      foreach ( $ArrayEnviar as $clave => $valor){
        $Cantidad = $valor[0];
        $htmlContent = "<h1>Certificado Extintores  </h1>";
        $htmlContent .="<h4>Actualmente posee  $Cantidad Extintores VENCIDOS  deber renovar sus certificado </h4>" ;
        $htmlContent .=  $valor[1];
        EmailHtml($clave,"SEGMARIND ADVERTENCIA", $htmlContent);

      }    
  
  }

  public function AlarmaCertificadoTraje(){

    $ArrayBalsasPorVencer = $this->ShipModels->Alarma();
  
    $COD =  utf8_encode('Código');
    foreach ($ArrayBalsasPorVencer as $Fila){
      $Usuario= $this->ClientModels->getClient($Fila->Armador);
      $Serial = $Fila->Serial;
      $DatosEditar = '{"0":"'. $Fila->$COD.'", "13":"1"}';
      $DatosEditar =  json_decode($DatosEditar, true);
      $isn= $this->ShipModels->Edit($DatosEditar);
    if($Usuario[0]->Correo != ""){
      $htmlContent = '<h1>Certificado De Traje</h1>';
      $htmlContent .="<p> Su Certificado De Trajes De Inmersión: $Serial, Esta Por VENCER actualmente tiene una vigencia de 30 dias.</p>";
      EmailHtml($Usuario[0]->Correo,"SEGMARIND ADVERTENCIA", $htmlContent);
    };
    }
  
    $ArrayBalsasVencidas = $this->ShipModels->Alarma2();
    foreach ($ArrayBalsasVencidas as $Fila){
      $Usuario= $this->ClientModels->getClient($Fila->Armador);
      $DatosEditar = '{"0":"'. $Fila->$COD.'","9":"Vencido", "13":"2"}';
        $DatosEditar =  json_decode($DatosEditar, true);
       
        $isn= $this->ShipModels->Edit($DatosEditar);
      if($Usuario[0]->Correo != ""){
    
        $Serial = $Fila->Serial;
        $htmlContent = '<h1>Certificado Traje </h1>';
        $htmlContent .="<p> Su Sertificado de trajes De Inmersión : $Serial, Esta Vencidad actualmente deber renovar su certificado .</p>";
        EmailHtml($Usuario[0]->Correo,"SEGMARIND ADVERTENCIA", $htmlContent);
     
        $this->MinutesModels->Edit($DatosEditar);
        
      };
      }
  
  }
}
